#include <bits/stdc++.h>
#include "ctree.h"
using namespace std;

const int maxn = 300005, inf = 1e9;
int n;
vector <int> adj [maxn], dp [maxn];
int par [maxn], sz [maxn];
vector <int> ans;

void rt (int a){
    sz [a] = 1;
    for (int i : adj [a]){
        if (i == par [a]) continue;
        par [i] = a;
        rt (i);
        sz [a] += sz [i];
    }
}

void dfs (int a){
    dp [a].clear ();
    dp [a].resize (n + 1, inf);
    dp [a][0] = 0;
    for (int i : adj [a]){
        if (i == par [a]) continue;
        dfs (i);
        vector <int> nxt (n + 1, inf);
        nxt [0] = 0;
        for (int j = 0; j <= n; j ++){
            for (int k = 0; j + k <= n; k ++){
                nxt [j + k] = min (nxt [j + k], dp [a][j] + dp [i][k]);
            }
        }
        dp [a] = nxt;
        dp [a][sz [i]] = min (dp [a][sz [i]], 1 + dp [i][max (0, sz [i] - n / 2)]);
    }
}

void find_ans (int a){
    int big = -1;
    for (int i : adj [a]){
        if (sz [i] > n / 2){
            big = i;
            break;
        }
    }
    if (big == -1){
        ans.push_back (0);
        return;
    }
    dfs (big);
    int x = inf;
    for (int i = sz [big] - n / 2; i <= n; i ++) x = min (x, dp [big][i]);
    ans.push_back (x);
}

vector <int> solve (int N, vector <int> X, vector <int> Y){

    n = N;
    for (int i = 0; i < n; i ++) adj [i].clear ();
    for (int i = 1; i < n; i ++){
        adj [X [i]].push_back (Y [i]);
        adj [Y [i]].push_back (X [i]);
    }
    ans.clear ();
    for (int i = 0; i < n; i ++){
        par [i] = -1;
        rt (i);
        find_ans (i);
    }
    return ans;

}
