#include "islands.h"
#include <bits/stdc++.h>

using namespace std;

std::vector<std::vector<int>> ask(const std::vector<std::vector<int>> &partition);

std::vector<int> solve(int N)
{
    int n=N;

    vector<int> outp(n,0);

    for(int i=0;i<N;i++)
    {
        vector<int> a={},b={i};
        for(int j=0;j<N;j++)
            if(j!=i)a.push_back(j);

        vector<std::vector<int>> ret=ask({a,b});

        for(auto w:ret)
            if(w.size()==1)
            {
                outp[i]=w[0];
            }
    }

    return outp;
}
/*
namespace {
using namespace std;

const int NMAX = 10000;
const int QMAX = 2 * NMAX;

int N;
int queries = 0, max_size = 0;
vector<int> real_perm;

void readTest() {
  assert(fscanf(stdin, "%d", &N) == 1);
  real_perm.resize(N);
  for (int &x : real_perm) {
    assert(fscanf(stdin, "%d", &x) == 1);
  }
}

void process_partition(vector<vector<int>> &query_partition) {
  static mt19937 mt(
      chrono::high_resolution_clock::now().time_since_epoch().count() ^ 666013 ^
      1000000007 ^ 23);
  shuffle(query_partition.begin(), query_partition.end(), mt);
  for (vector<int> &v : query_partition) {
    shuffle(v.begin(), v.end(), mt);
    for (int &x : v) {
      x = real_perm[x];
    }
  }
}

} // namespace

vector<vector<int>> ask(const vector<vector<int>> &partition) {
  // Check partition.
  ++queries;
  max_size = max(max_size, (int) partition.size());
  vector<bool> vis(N, false);
  bool ok = true;
  int cnt_vals = 0;
  for (int i = 0; i < static_cast<int>(partition.size()) && ok; ++i) {
    if (partition[i].empty()) {
      ok = false;
    }
    for (int j = 0; j < static_cast<int>(partition[i].size()) && ok; ++j) {
      const int val = partition[i][j];
      if (val < 0 || val >= N || vis[val]) {
        ok = false;
      }
      vis[val] = true;
      ++cnt_vals;
    }
  }
  if (cnt_vals < N) {
    ok = false;
  }
  if (!ok) {
    std::cout << "Bad query." << std::endl;
    exit(0);
  }
  vector<vector<int>> cp_partition(partition);
  process_partition(cp_partition);
  return cp_partition;
}

int main() {
  readTest();
  const vector<int> sol_contestant = solve(N);

  std::cout << "Your program guessed:" << std::endl;

  for (int num : sol_contestant)
  {
    std::cout << num << " ";
  }

  std::cout << "Queries: " << queries << "\nMax size: " << max_size << std::endl;

  return 0;
}
*/
