#include "ctree.h"
#include<bits/stdc++.h>
using namespace std;

const int nmax=3e5+42;

int n;
vector<int> adj[nmax];

int SZ[nmax];

void dfs(int node,int par)
{
    SZ[node]=1;
    for(auto w:adj[node])
        if(w!=par)
        {
            dfs(w,node);
            SZ[node]+=SZ[w];
        }
}

vector<int> children;

int cut(int me)
{
    for(int i=children.size()-1;i>=0;i--)
    {
        me=me-children[i];

        if(me<=n/2)return children.size()-i;
    }

    return 1e9;
}
int eval(int node)
{
    int subtree_size=-1;

    int node_other=node;

    while(1)
    {
        bool go=0;

        for(auto w:adj[node_other])
            if(SZ[w]<SZ[node_other]&&SZ[w]>n/2)
            {
                go=1;

                node_other=w;
                break;
            }
        if(go==0)break;

        if(subtree_size==-1)subtree_size=SZ[node_other];
    }

    if(subtree_size==-1)return 0;

    children={};

    for(auto w:adj[node_other])
        if(SZ[w]<SZ[node_other])children.push_back(SZ[w]);

    sort(children.begin(),children.end());

    //cout<<node<<" -> "<<node_other<<" "<<subtree_size<<endl;

    //cout<<"children: ";for(auto w:children)cout<<w<<" ";cout<<endl;

    return min(1+cut(SZ[node_other]),cut(subtree_size));
}
std::vector<int> solve(int N, std::vector<int> X, std::vector<int> Y)
{
    n=N;
    for(int i=0;i<n;i++)adj[i]={};

    for(int i=0;i<n-1;i++)
    {
        adj[X[i]].push_back(Y[i]);
        adj[Y[i]].push_back(X[i]);
    }

    vector<int> outp={};
    for(int i=0;i<n;i++)
    {
        dfs(i,i);

        outp.push_back(eval(i));
    }
    return outp;
}
/*
int main(){
    int N, T;
    std::cin >> T;
    for(int t = 1; t <= T; t++) {
        std::cin >> N;
        std::vector<int> X(N - 1), Y(N - 1);
        for (int i = 0; i < N - 1; i++) {
            std::cin >> X[i] >> Y[i];
        }
        std::vector<int> answers = solve(N, X, Y);
        for (auto answer: answers)
            std::cout << answer << ' ';
        std::cout << '\n';
    }
    return 0;
}
*/
