#include <bits/stdc++.h>
#include "islands.h"

using namespace std;
typedef long long ll;
#define all(x) (x).begin(), (x).end()
template<class T> void check_min(T &a, const T b){ a = (a < b) ? a : b; }
template<class T> void check_max(T &a, const T b){ a = (a > b) ? a : b; }

vector<vector<int>> ask(const vector<vector<int>> &partition);

const int N = 1e4 + 3;

int n;
pair<int, int> r[N];
vector<pair<int, int>> ranges;

void dnc(){
    int mx = 0;
    for(pair<int, int> range: ranges)
        check_max(mx, range.second - range.first + 1);
    if(mx <= 2) return;

    /*cout << "ranges: ";
    for(pair<int, int> range: ranges)
        cout << range.first << " " << range.second << endl;
    cout << endl;*/

    vector<vector<int>> p;
    for(pair<int, int> range: ranges){
        int sz = range.second - range.first + 1;
        int pos = range.first;
        for(int i = 1; sz; ++i){
            if(i > sz){
                for(int j = pos; j <= range.second; ++j)
                    p.back().push_back(j);
                break;
            }
            p.push_back({});
            for(int j = pos; j <= pos + i - 1; ++j)
                p.back().push_back(j);
            pos += i;
            sz -= i;
        }
    }

    /*cout << "p: " << endl;
    for(vector<int> v: p){
        for(int x: v)
            cout << x << " ";
        cout << endl;
    }*/

    ranges.clear();
    vector<vector<int>> new_p = ask(p);
    for(vector<int> part: new_p){
        pair<int, int> range = r[part[0]];
        int sz = part.size();
        pair<int, int> new_range;
        if(sz * (sz + 1) / 2 > range.second - range.first + 1){
            new_range = {range.second - sz + 1, range.second};
        }
        else new_range = {range.first + sz * (sz - 1) / 2, range.first + sz * (sz + 1) / 2 - 1};

        for(int x: part)
            r[x] = new_range;
        ranges.push_back(new_range);
    }
    dnc();
}

vector<int> solve(int _n){
    n = _n;
    for(int i = 0; i < n; ++i)
        r[i] = {0, n - 1};
    ranges.push_back({0, n - 1});
    dnc();

    vector<int> singles;
    for(pair<int, int> range: ranges)
        if(range.first == range.second)
            singles.push_back(range.first);

    vector<vector<int>> p;
    for(pair<int, int> range: ranges){
        if(range.second - range.first + 1 == 2){
            int s = singles.back();
            singles.pop_back();

            p.push_back({range.first});
            p.push_back({range.second, s});
        }
    }
    for(int x: singles)
        p.push_back({x});

    vector<vector<int>> new_p = ask(p);
    for(vector<int> v: new_p){
        if(v.size() == 1){
            int x = v[0];
            if(r[x].second - r[x].first + 1 == 2){
                r[x].second = r[x].first;
            }
        }
        else if(v.size() == 2){
            int x = v[0];
            if(r[x].second - r[x].first + 1 != 2) x = v[1];
            r[x].first = r[x].second;
        }
    }

    vector<int> ans(n);
    for(int i = 0; i < n; ++i)
        ans[r[i].first] = i;
    return ans;
}

