#include <vector>

std::vector<int> solve(int N);

std::vector<std::vector<int>> ask(const std::vector<std::vector<int>> &partition);

#include <bits/stdc++.h>
using namespace std;
//#pragma GCC target("sse4")
//#pragma GCC optimize("Ofast")
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) {out << x.first << " " << x.second; return out;}
template<class T, class T2> inline istream &operator >>(istream & in, pair<T, T2> &x) {in >> x.first >> x.second; return in;}
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) {return x < y ? x = y, 1 : 0;}
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) {return x > y ? x = y, 1 : 0;}

const int MAX_N = 1e5 + 10;
int place[MAX_N];

template<class T> bool cmp (const T &a, const T &b) {
    return a.size() < b.size();
}

vector<int> solve(int N) {
    for(int i = 0; i < N; i ++) {
        place[i] = 0;
    }
if(N <= 5000) {
    int zer = -1;
    vector<vector<int> > toAsk;
    if(N % 2 == 0) {
        toAsk.push_back({0});
        toAsk.push_back({});
        for(int i = 1; i < N; i ++) {
            toAsk.back().push_back(i);
        }
        auto wild = ask(toAsk);
        for(auto &it : wild) {
            if(it.size() == 1) {
                zer = it[0];
                place[zer] = 0;
            }
        }
    }
    for(int i = 0; (1 << i) < N; i ++) {
        toAsk = {{}, {}};
        for(int j = N - 1; j >= 0; j --) {
            if(j & (1 << i)) {
                toAsk[0].push_back(j);
            } else {
                toAsk[1].push_back(j);
            }
        }
        if(toAsk[0].size() == toAsk[1].size()) {
            toAsk[1].pop_back();
            toAsk[0].push_back(0);
        }
        int cnt = toAsk[0].size();
        auto ans = ask(toAsk);
        for(auto &it : ans) {
            if(it.size() != cnt) {continue;}
            for(int j = 0; j < it.size(); j ++) {
                place[it[j]] += (1 << i);
            }
        }
    }
    if(zer != 0) {
        place[zer] = 0;
    }
    vector<int> ret(N);
    for(int i = 0; i < N; i ++) {
        ret[place[i]] = i;
    }
    return ret;

} else {
    for(int i = 0; (1 << i) < N; i += 2) {
        vector<int> nowAsk[4];
        for(int j = 0; j < N; j ++) {
            nowAsk[(j & (3 << i)) >> i].push_back(j);
        }
        vector<vector<int> > toAsk;
        for(int j = 0; j < 4; j ++) {
            for(int k = 0; k < nowAsk[j].size(); k += (20 << j)) {
                toAsk.push_back({});
                if(k + (20 << (j + 1)) > nowAsk[j].size()) {
                    for(int l = k; l < nowAsk[j].size(); l ++) {
                        toAsk.back().push_back(nowAsk[j][l]);
                    }
                    break;
                } else {
                    for(int l = k; l < k + (20 << j); l ++) {
                        toAsk.back().push_back(nowAsk[j][l]);
                    }
                }
            }
        }
        auto ans = ask(toAsk);
        for(auto &it : ans) {
            int howm = 0;
            while((it.size() >> howm) > 20) {howm ++;}
            for(auto itt : it) {
                place[itt] |= howm << i;
            }
        }
    }
    vector<int> ret(N);
    for(int i = 0; i < N; i ++) {
        ret[place[i]] = i;
    }
    return ret;
}
}
