#include <vector>

std::vector<int> solve(int N, std::vector<int> X, std::vector<int> Y);

#include <bits/stdc++.h>
using namespace std;
#pragma GCC target("sse4")
//#pragma GCC optimize("Ofast")
#define endl "\n"
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) {out << x.first << " " << x.second; return out;}
template<class T, class T2> inline istream &operator >>(istream & in, pair<T, T2> &x) {in >> x.first >> x.second; return in;}
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) {return x < y ? x = y, 1 : 0;}
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) {return x > y ? x = y, 1 : 0;}

const int MAX_N = 3e5 + 10;
vector<int> g[MAX_N];
int sz[MAX_N], par[MAX_N];
int cent[MAX_N], n;
int cnt = 0, who;

void dfs(int x, int p) {
    sz[x] = 1;
    par[x] = p;
    bool flag = true;
    for(auto it : g[x]) {
        if(it == p) {continue;}
        dfs(it, x);
        sz[x] += sz[it];
        if(sz[it] > n / 2) {flag = false;}
    }
    if(n - sz[x] > n / 2) {flag = false;}
    cent[x] = flag;
    if(flag) {who = x; cnt ++;}
}

vector<int> ret;

vector<int> sum, pref;

int calcFor(int cnt, int bad) {
    if(cnt > bad) {
        return sum[cnt - 1] - pref[bad];
    } else if(cnt != 0) {
        return sum[cnt - 1];
    } else {
        return 0;
    }
}

void getAns(int x, int p, int val) {
    ret[x] = val + 1;
    //cout << "Giving " << x << " " << val << endl;
    for(auto it : g[x]) {
        if(it == p) {continue;}
        getAns(it, x, val);
    }
}

void getAnsBetter(int x, int p, int wh, int fatherR) {
    //cout << "Giving " << x << " " << val << endl;
    int l = fatherR - 1, r = pref.size();
    while(l < r - 1) {
        int m = (l + r) / 2ll;
        if(n - sz[x] + calcFor(m, wh) > n / 2) {
            l = m;
        } else {
            r = m;
        }
    }
    for(auto it : g[x]) {
        if(it == p) {continue;}
        getAnsBetter(it, x, wh, r);
    }
    if(r > wh) {
        chkmin(ret[x], r - 1);
    } else {
        chkmin(ret[x], r);
    }
}

vector<int> solve(int N, vector<int> X, vector<int> Y) {
    n = N;
    cnt = 0;
    ret.resize(0);
    pref.resize(0);
    for(int i = 0; i < N; i ++) {
        g[i].resize(0);
        cent[i] = 0;
    }
    for(int i = 0; i < N - 1; i ++) {
        g[X[i]].push_back(Y[i]);
        g[Y[i]].push_back(X[i]);
    }
    dfs(0, -1);
    if(cnt == 2) {
        for(int i = 0; i < n; i ++) {
            if(cent[i]) {
                ret.push_back(0);
            } else {
                ret.push_back(1);
            }
        }
        return ret;
    }
    dfs(who, -1);
    for(auto it : g[who]) {
        pref.push_back(-sz[it]);
    }
    sort(pref.begin(), pref.end());
    sum.resize(pref.size());
    for(int i = 0; i < pref.size(); i ++) {
        sum[i] = pref[i];
        if(i > 0) {sum[i] += sum[i - 1];}
    }
    ret.resize(n);
    for(auto it : g[who]) {
        int wh = find(pref.begin(), pref.end(), -sz[it]) - pref.begin();
        int l = 0, r = pref.size();
        //cout << it << " " << l << " " << r << " " << wh << endl;
        while(l < r - 1) {
            int m = (l + r) / 2ll;
            if(n - sz[it] + calcFor(m, wh) > n / 2) {
                l = m;
            } else {
                r = m;
            }
        }
        //cout << l << " " << r << " " << wh << endl;
        if(r > wh) {
            getAns(it, who, r - 1);
        } else {
            getAns(it, who, r);
        }
        getAnsBetter(it, who, wh, max(1, r - 1));
    }
    return ret;
}
