#include <iostream>
#include <algorithm>
#include <string.h>
#include <vector>
using namespace std;
const int MAXN=3e5+10;
vector <int> v[MAXN], ans;
int ss[MAXN], mi[MAXN], start;
int dfs_ss(int x, int p) {
    ss[x]=1;
    for (auto i:v[x]) {
        if (i==p) continue;
        ss[x]+=dfs_ss(i,x);
    }
    return ss[x];
}
int dfs(int x, int p, int cur_s) {
    if (cur_s==0) return 0;
    int s0=-1;
    for (auto i:v[x]) {
        if (i==p) continue;
        if (ss[i]<cur_s+1) continue;
        if (s0==-1) s0=dfs(i,x,cur_s);
        else s0=min(s0,dfs(i,x,cur_s));
    }
    ///cout << x << ' ' << cur_s << ' ' << s0 << endl;
    vector <pair <int,int> > cur;
    for (auto i:v[x]) {
        if (i==p) continue;
        cur.push_back({-ss[i],i});
    }
    sort(cur.begin(),cur.end());
    int s1, s2, sum=0;
    s1=s0;
    s2=-1;
    for (auto i:cur) {
        ///cout << -i.first << ' ' << i.second << ' ' << mi[x] << endl;
        if (-i.first>=cur_s) {
            if (s1==-1) s1=dfs(i.second,x,mi[i.second])+1;
            else s1=min(s1,dfs(i.second,x,mi[i.second])+1);
        } else {
            if (sum>cur_s) break;
            sum+=-i.first;
            s2++;
        }
    }
    ///cout << s1 << ' ' << s2 << endl;
    if (s1==-1) return s2;
    if (s2==-1) return s1;
    return min(s1,s2);
}
vector <int> solve(int n, vector<int> x, vector <int> y) {
    for (int i=0;i<n;i++) {
        if (v[i].size()!=0) v[i].clear();
    }
    for (int i=0;i<n-1;i++) {
        v[x[i]].push_back(y[i]);
        v[y[i]].push_back(x[i]);
    }
    if (ans.size()!=0) ans.clear();
    for (int i=0;i<n;i++) {
        memset(ss,0,sizeof(ss));
        start=i;
        ///cout << i << endl;
        dfs_ss(i,-1);
        for (int j=0;j<n;j++) {
            if (j!=i) mi[j]=max(0,ss[j]-n/2);
            else mi[j]=0;
        }
        bool fl=false;
        for (auto j:v[i]) {
            if (mi[j]==0) continue;
            ans.push_back(dfs(j,i,mi[j]));
            fl=true;
            break;
        }
        if (!fl) ans.push_back(0);
    }
    return ans;
}
/**
int main(){
    int N, T;
    cin >> T;
    for(int t = 1; t <= T; t++) {
        cin >> N;
        vector<int> X(N - 1), Y(N - 1);
        for (int i = 0; i < N - 1; i++) {
            cin >> X[i] >> Y[i];
        }
        vector<int> answers = solve(N, X, Y);
        for (auto answer: answers)
            cout << answer << ' ';
        cout << '\n';
    }
    return 0;
}
/**
2
3
0 1
0 2
7
1 0
1 2
2 3
3 4
5 1
1 6
**/
