#include <iostream>
#include <algorithm>
#include <string.h>
#include <vector>
#include "ctree.h"
using namespace std;
const int MAXN=3e5+10;
vector <int> v[MAXN], ans;
int ss[MAXN], mi[MAXN], cnt[MAXN];
int dfs_ss(int x, int p) {
    ss[x]=1;
    for (auto i:v[x]) {
        if (i==p) continue;
        ss[x]+=dfs_ss(i,x);
    }
    return ss[x];
}
int dfs(int x, int p, int cur_s) {
    if (cur_s==0) return 0;
    if (ss[x]<=cur_s) return MAXN;
    int s0=MAXN, s1;
    for (auto i:v[x]) {
        if (i==p) continue;
        if (ss[i]>=cur_s) s1=dfs(i,x,mi[i])+1;
        else s1=MAXN;
        ///cout << x << ' ' << i << ' ' << cur_s << ' ' << s1 << endl;
        s0=min(s0,min(s1,dfs(i,x,cur_s)));
    }
    if (s0==MAXN) {
        vector <int> cur;
        int maxs=0;
        for (auto i:v[x]) {
            if (i==p) continue;
            cnt[ss[i]]=0;
        }
        for (auto i:v[x]) {
            if (i==p) continue;
            cnt[ss[i]]++;
            maxs=max(maxs,ss[i]);
        }
        for (int i=maxs;i>=1;i--) {
            for (int j=cnt[i];j>0;j--) cur.push_back(i);
        }
        int ans, sum;
        ans=sum=0;
        for (auto i:cur) {
            sum+=i;
            ans++;
            if (sum>=cur_s) break;
        }
        return ans;
    }
    return s0;
}
vector <int> solve(int n, vector<int> x, vector <int> y) {
    for (int i=0;i<n;i++) {
        if (!v[i].empty()) v[i].clear();
    }
    for (int i=0;i<n-1;i++) {
        v[x[i]].push_back(y[i]);
        v[y[i]].push_back(x[i]);
    }
    if (ans.size()!=0) ans.clear();
    for (int i=0;i<n;i++) {
        memset(ss,0,sizeof(ss));
        ///cout << i << endl;
        dfs_ss(i,-1);
        for (int j=0;j<n;j++) {
            if (j!=i) mi[j]=max(0,ss[j]-n/2);
            else mi[j]=0;
        }
        bool fl=false;
        for (auto j:v[i]) {
            if (mi[j]==0) continue;
            ans.push_back(dfs(j,i,mi[j]));
            fl=true;
            break;
        }
        if (!fl) ans.push_back(0);
    }
    return ans;
}
/**
int main(){
    int N, T;
    cin >> T;
    for(int t = 1; t <= T; t++) {
        cin >> N;
        vector<int> X(N - 1), Y(N - 1);
        for (int i = 0; i < N - 1; i++) {
            cin >> X[i] >> Y[i];
        }
        vector<int> answers = solve(N, X, Y);
        for (auto answer: answers)
            cout << answer << ' ';
        cout << '\n';
    }
    return 0;
}
/**
2
3
0 1
0 2
7
1 0
1 2
2 3
3 4
5 1
1 6

1
9
1 2
1 3
3 0
3 4
3 5
3 6
3 7
3 8
**/
