#include <vector>

std::vector<int> solve(int N);

std::vector<std::vector<int>> ask(const std::vector<std::vector<int>> &partition);

#include <bits/stdc++.h>
using namespace std;
//#pragma GCC target("sse4")
//#pragma GCC optimize("Ofast")
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) {out << x.first << " " << x.second; return out;}
template<class T, class T2> inline istream &operator >>(istream & in, pair<T, T2> &x) {in >> x.first >> x.second; return in;}
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) {return x < y ? x = y, 1 : 0;}
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) {return x > y ? x = y, 1 : 0;}

const int MAX_N = 1e5 + 10;

map<int, int> mp[MAX_N];

template<class T> bool cmp (const T &a, const T &b) {
    return a.size() < b.size();
}

vector<int> solve(int N) {
    vector<vector<int> > toAsk;
    vector<int> ind;
    for(int i = 0; i < N; i ++) {
        ind.push_back(i);
    }
    const int QUERIES = 5;
    for(int q = 0; q < QUERIES; q ++) {
        toAsk = {};
        random_shuffle(ind.begin(), ind.end());
        int lft = N, indn = 0;
        for(int i = 1; i <= lft; i ++) {
            toAsk.push_back({});
            if(2 * i >= lft) {i = lft;}
            for(int j = indn; j < indn + i; j ++) {
                toAsk.back().push_back(ind[j]);
            }
            lft -= i;
            indn += i;
        }
        auto ansNow = ask(toAsk);
        sort(ansNow.begin(), ansNow.end(), cmp<vector<int> >);
        for(int i = 0; i < toAsk.size(); i ++) {
            for(int j = 0; j < toAsk[i].size(); j ++) {
                for(int k = 0; k < toAsk[i].size(); k ++) {
                    mp[toAsk[i][j]][ansNow[i][k]] ++;
                }
            }
        }
    }
    vector<int> ret(N);
    for(int i = 0; i < N; i ++) {
        for(auto it : mp[i]) {
            if(it.second == QUERIES) {
                ret[it.first] = i;
            }
        }
    }
    return ret;
}
