//#include "Lgrader.cpp"
#include "islands.h"

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;

bool cmp(vector<int> &x, vector<int> &y)
{
    return x.size() < y.size();
}

vector<int> solve(int N)
{
    vector<int> ans(N, 0);
    vector<set<int>> fp;

    int sum = 0, cnt = 0;
    while (sum < N)
    {
        sum += ++cnt;
    }
    if (sum > N) cnt--;

    for (int i = 1; i < cnt; ++ i)
    {
        fp.push_back({});
    }

    for (int i = cnt - 1; i >= 1; -- i)
    {
        vector<vector<int>> v;
        vector<int> last;
        int idx = 0;
        for (int j = 1; j <= cnt; ++ j)
        {
            vector<int> vv;

            if (j == i - 1) // use for the last, but not now
            {
                /*int from = cnt * (cnt - 1) / 2;
                for (int k = from; k < from + i - 1; ++ k)
                {
                    vv.push_back(k);
                }
                v.push_back(vv); //*/
            }
            if (j < i) // dispose elements
            {
                for (int k = idx; k < idx + j; ++ k)
                {
                    last.push_back(k);
                }
                idx += j;
                continue;
            }

            int to = idx + j;
            if (j == cnt) to = N;
            //if (j != cnt) also for the last
                for (int k = idx; k < idx + i - 1; ++ k) last.push_back(k);
            for (int k = idx + i - 1; k < to; ++ k) vv.push_back(k);
            v.push_back(vv);
            idx += j;
        }

        for (int e : last) v.back().push_back(e);

        vector<vector<int>> res = ask(v);
        sort(res.begin(), res.end(), cmp);
        sort(v.begin(), v.end(), cmp);


        /*cout << "ask for " << v.size() << endl;
        for (int j = 0; j < v.size(); ++ j)
        {
            cout << "part size " << v[j].size() << ' ';
            for (int k = 0; k < v[j].size(); ++ k)
            {
                cout << v[j][k] << ' ';
            }
//            cout << endl << "ans: ";
//            for (int k = 0; k < v[j].size(); ++ k)
//            {
//                cout << res[j][k] << ' ';
//            }
            cout << endl;
        }
        //*/

        int from = 0;
        for (int j = from; j < res.size() - 1; ++ j)
        {
            int idx = i + j - from - 1;
            int pos = v[j][0];
            int val;

            // cout << "control: " << j << ' ' << idx << ' ' << pos << endl;
            for (int k = 0; k < res[j].size(); ++ k)
            {
                if (fp[idx].count(res[j][k]) == 0)
                {
                    val = res[j][k];
                    fp[idx].insert(res[j][k]);
                    break;
                }
            }
            ans[pos] = val;
            // cout << "found " << val << " on pos " << pos << endl;
        }
    }

    for (int i = cnt * (cnt - 1) / 2; i < N; ++ i)
    {
        vector<vector<int>> v;
        v.emplace_back();
        v.emplace_back();
        v[0].push_back(i);
        for (int j = 0; j < i; ++ j) v[1].push_back(j);
        for (int j = i + 1; j < N; ++ j) v[1].push_back(j);

        v = ask(v);
        if (v[0].size() != 1) swap(v[0], v[1]);
        ans[i] = v[0][0];
    }

    // cout << endl << endl << endl;

    return ans;
}

/*int main()
{
    solve(17);
}*/

/*
20
0 9 3 4 6 2 8 1 5 7 18 13 11 16 15 12 14 19 17 10
*/

