//#include "Lgrader.cpp"
#include "islands.h"

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;

bool cmp(vector<int> &x, vector<int> &y)
{
    return x.size() < y.size();
}

int find_val(int pos, int N)
{
    vector<vector<int>> v;
    v.emplace_back();
    v.emplace_back();
    v[0].push_back(pos);
    for (int j = 0; j < pos; ++ j) v[1].push_back(j);
    for (int j = pos + 1; j < N; ++ j) v[1].push_back(j);

    v = ask(v);
    if (v[0].size() != 1) swap(v[0], v[1]);
    return v[0][0];
}

vector<int> solve(int N)
{
    vector<int> ans(N, 0);
    vector<set<int>> fp;
    set<int> fpl;

    int sum = 0, cnt = 0;
    while (sum < N)
    {
        sum += ++cnt;
    }
    if (sum > N) cnt--;

    for (int i = 1; i < cnt; ++ i)
    {
        fp.push_back({});
    }

    ans[cnt * (cnt - 1) / 2] = find_val(cnt * (cnt - 1) / 2, N);
    fpl.insert(ans[cnt * (cnt - 1) / 2]);

    int border = cnt * (cnt - 1) / 2;
    for (int i = cnt - 1; i >= 1; -- i)
    {
        vector<vector<int>> v;
        vector<int> last;
        int idx = 0;
        for (int j = 1; j <= cnt; ++ j)
        {
            vector<int> vv;

            if (j == 1 + cnt - i)
            {
                int from = cnt * (cnt - 1) / 2;
                int to = from + 1 + cnt - i;
                for (int k = from; k < to; ++ k)
                {
                    vv.push_back(k);
                }

                if (i == 1) for (int e : vv) last.push_back(e);
                else v.push_back(vv);
                vv.clear();
                //*/
            }
            if (j < i) // dispose elements
            {
                for (int k = idx; k < idx + j; ++ k)
                {
                    last.push_back(k);
                }
                idx += j;
                continue;
            }

            int to = idx + j;
            if (j == cnt)
            {
                for (int k = cnt * (cnt - 1) / 2 + 1 + cnt - i; k < N; ++ k) last.push_back(k);
            }
            if (j != cnt)
            {
                for (int k = idx; k < idx + i - 1; ++ k) last.push_back(k);
                for (int k = idx + i - 1; k < to; ++ k) vv.push_back(k);
            }
            v.push_back(vv);
            idx += j;
        }

        for (int e : last) v.back().push_back(e);

        vector<vector<int>> res = ask(v);
        sort(res.begin(), res.end(), cmp);
        sort(v.begin(), v.end(), cmp);

        /*
        cout << endl << "ask for " << v.size() << endl;
        for (int j = 0; j < v.size(); ++ j)
        {
            cout << "part size " << v[j].size() << ' ';
            for (int k = 0; k < v[j].size(); ++ k)
            {
                cout << v[j][k] << ' ';
            }
//            cout << endl << "ans: ";
//            for (int k = 0; k < v[j].size(); ++ k)
//            {
//                cout << res[j][k] << ' ';
//            }
            cout << endl;
        }
        cout << endl;
        //*/

        int fl = (i != 1);
        for (int j = 0; j < res.size() - 1 - fl; ++ j)
        {
            int idx = i + j - 1;
            int pos = v[j][0];
            int val;

            // cout << "control: " << j << ' ' << idx << ' ' << pos << endl;
            for (int k = 0; k < res[j].size(); ++ k)
            {
                if (fp[idx].count(res[j][k]) == 0)
                {
                    val = res[j][k];
                    fp[idx].insert(res[j][k]);
                    break;
                }
            }
            ans[pos] = val;
            // cout << "found " << val << " on pos " << pos << endl;
        }

        if (i != 1)
        {
            border++;
            for (int k = 0; k < res[res.size() - 2].size(); ++ k)
            {
                if (fpl.count(res[res.size() - 2][k]) == 0)
                {
                    fpl.insert(res[res.size() - 2][k]);
                    ans[border] = res[res.size() - 2][k];
                }
            }
        }
    }

    for (int i = border + 1; i < N; ++ i)
    {
        ans[i] = find_val(i, N);
    }

    // cout << endl << endl << endl;

    return ans;
}

/*int main()
{
    solve(17);
}*/

/*
20
0 9 3 4 6 2 8 1 5 7 18 13 11 16 15 12 14 19 17 10
*/

