#include "islands.h"
#include <iostream>
#include <algorithm>
#include <queue>

using namespace std;

bool cmp(vector<int> A, vector<int> B)
{
    return A.size() < B.size();
}

vector<int> solve(int n)
{
    queue<int> toFix;
    for(int i = 0; i < n; i++){
        toFix.push(i);
    }
    vector<int> ans;
    ans.resize(n, -1);
    int groups;
    int s = 0;
    int perfectSplit = 1;
    for(groups = 1; s <= n; groups++){
        s += groups;
        if(s == n){
            perfectSplit = 0;
        }
    }
    groups--;
    s -= groups;
    groups--;
    s -= groups;

    vector<int> solved;
    for(int i = 1; solved.size() < n; i++){
        int it = 0;
        vector<vector<int> > q;
        q.resize(groups);
        for(int k = 0; k < min(groups-perfectSplit, i) && !toFix.empty(); k++){
            q[k].push_back(toFix.front());
            toFix.pop();
        }
        int it2 = toFix.front();
        for(int k = 0; k < groups; k++){
            while(q[k].size() < k+1 || (k == groups-1 && q[k].size() < n-s)){
                if(it < solved.size()){
                    q[k].push_back(solved[it]);
                    it++;
                }else{
                    q[k].push_back(it2);
                    it2++;
                }
            }
        }
        q = ask(q);
        sort(q.begin(), q.end(), cmp);
        for(int k = 0; k < min(groups-perfectSplit, i); k++){
            for(int h = 0; h < q[k].size(); h++){
                if(ans[q[k][h]] == -1){
                    ans[q[k][h]] = solved.size();
                    solved.push_back(solved.size());
                    break;
                }
            }
        }
    }
    return ans;
}
